# _05_old_vs_new_vs_newest_string_formatting_features.py
# Compare old, new, and newest Python string formatting features.


def main():
    quantity = 25
    length = 10.5
    price = 99.99

    percent_notation_approach = 'I have %d widgets that are %0.2f feet long; they each cost $%0.2f.' % (
        quantity, length, price)
    print(percent_notation_approach, '<-- % notation approach')

    string_dot_format_approach = 'I have {0} widgets that are {1:0.2f} feet long; they each cost ${2:0.2f}.'.format(
        quantity,
        length,
        price)
    print(string_dot_format_approach, '<-- string.format() approach')

    f_string_approach = f'I have {quantity} widgets that are {length:0.2f} feet long; they each cost ${price:0.2f}.'
    print(f_string_approach, '<-- f-string approach')


main()
